CON
  _clkmode = xtal1 + pll16x
  _XinFREQ = 5_000_000
  lf = 13
  ClearScreen = 0
  errorCol = 2
  normCol = 0
  pinD1 = 4
  pinD0 = 5
OBJ
  term : "PC_Interface"
  tiLib : "TICommLib"

VAR
  byte data[4]
   byte bRec   

  

Pub GO | key, spinCnt
  term.start(31,30)
  tiLib.start(pinD1,pinD0)
  'vp.start(31, 30,@spinCnt,String("bSend%,ina^")  )
  'outa[D1] := 1
  term.out(ClearScreen)
  term.str(string("TI-92 interface demo"))
  term.out(lf)
  term.str(string("   Copyright 2007 Vistar Web Tech"))
  term.out(lf)
  term.str(string("   Developed by Michael Schwab"))
  'data[0] := $08
  'data[1] := $87
  'data[2] := $21
  'data[3] := $00
  term.out(lf)  
  repeat
    Menu
    'dira[23] :=1
    'outa[23] := 1
    'sendCharsNoUI
    'outa[23] := 0
    'waitcnt(cnt + 10_000_000)

pri testComms | sTime  ' wiggles the both bit lines and waits for responses from the
  term.out(ClearScreen)
  term.str(string("Verifing connection..."))
  term.out(lf)

  if NOT \tiLib.commReady
    term.setcol(errorCol)
    term.str(string("TI-92 not detected"))
    term.out(lf)
    'term.bin(ina & %00000000000000000000000000110000,8) 
    term.setcol(normCol) 
  else
    term.str(string(" TI-92 appears to be connected."))
    term.out(lf)
    if NOT \tiLib.sendTIBit1
      term.setcol(errorCol)
      term.str(string("1 bit send error"))
      term.out(lf)
      term.setcol(normCol)
    else
      term.str(string("1 bit sent and acknowledged"))
      term.out(lf)
    if NOT \tiLib.sendTIBit0
      term.str(string("0 bit send error"))
      term.out(lf)
    else
      term.str(string("0 bit sent and acknowledged"))
      term.out(lf)
   ' waitcnt(cnt + 100_000_000) 
    
   'waitcnt(cnt + 200_000_000)
  



pri showDAStatus
   term.bin(ina & %00000000000000000000000000110000,8)
   term.out(lf)
 

    
PRI Menu  | key         ' Displays the menu at the bottom of the screen
 
  'term.out(ClearScreen)
  menuBox
  term.str(string("F5-ReBoot"))
  term.locate(95,190)
  term.str(string("F1-TestComms"))
  term.locate(200,190)
  term.str(string("F2-Interact"))
  'term.locate(250,190)
'  term.str(string("F3-Show"))
  term.locate (0,0)
  handleMenuKeys
  
pri menuBox
  term.box(0,180,300,30)
  term.locate(15,190)   

pri Interact | key
  term.out(ClearScreen)
  menuBox
  term.str(string("Esc-Exit Interact"))
  term.locate(0,0)
  term.str(string("Tab -> Esc, F9- > STO>"))
  term.out(lf)
  term.str(string("F11 -> Apps, F12 -> Mode"))
  term.out(lf)
  repeat
    key := term.getKey
    term.hex(key,2)
    term.str(string(" "))
    case key
      $09 :            ' I'm mapping the tab key to Esc on the calc since that's used for other things.
        TI92SendKey($01,$08)
      $CB :
        term.out(ClearScreen)
        Menu
        Return
      $28  :                 ' Maps (
        TI92SendKey($00,$28)
      $29 :                 ' Maps )
        TI92SendKey($00,$29)  
      $00..$7F :
        TI92SendKey($00,key)
      
      $C8 :                     ' backspace
        TI92SendKey($01,$01)
'      $??
'        TI92SendKey($01,$02)    ' Store
      $D0 :
        TI92SendKey($01,$0C + key & %00001111)    ' F1
      $D1 :
        TI92SendKey($01,$0C + key & %00001111)    ' F2
      $D2 :
        TI92SendKey($01,$0E)    ' F3
      $D3 :
        TI92SendKey($01,$0F)    ' F4
      $D4 :
        TI92SendKey($01,$10)    ' F5
      $D5 :
        TI92SendKey($01,$11)    ' F6
      $D6 :
        TI92SendKey($01,$12)    ' F7
      $D7 :
        TI92SendKey($01,$13)    ' F8
      $D8 :                     ' F9 on the Keyboard will be STO> on the calc
        TI92SendKey($01,$02)
      $D9 :
        TI92SendKey($01,$0A)    ' F12 -> Mode 
      $DA :                     ' F11 -> Apps
        TI92SendKey($01,$09)
      $C2 :
        TI92SendKey($01,$52)    ' Up Arrow
      $C3 :
        TI92SendKey($01,$58)    ' Down Arrow
      $C0 :
        TI92SendKey($01,$51)    ' Left Arrow
      $C1 :
        TI92SendKey($01,$54)    ' Right Arrow

        

    
pri TI92SendKey(bKey1,bKey2)
  if NOT \tiLib.SendByte($09)
    term.hex($09,2)
    term.str(string(" send error")) 
  if NOT \tiLib.SendByte($87)
    term.hex($87,2)
    term.str(string(" send error"))
  if NOT \tiLib.SendByte(bKey2)
    term.hex(bKey2,2)
    term.str(string(" send error"))
  if NOT \tiLib.SendByte(bKey1)
    term.hex(bKey1,2)
    term.str(string(" send error"))

  if NOT \tiLib.recData
      term.str(string("error rec bytes"))     
    
  
pri handleMenuKeys | key
  key := 0 
  repeat while key == 0 
    key := term.getkey
    term.hex(key,2)
    if key > 0
      term.out(ClearScreen) 
      case key
        '$D0 : term.str(string("F1 pressed"))
        $D0 : TestComms
        $D1 : Interact
        $D4 : Reboot
        $0D : term.str(string("enter"))
    
   Menu